import { World, Commands } from "Minecraft";
import { Utilities } from "./Utilities.js";

const prefix = "!";
let brush = [];

World.events.beforeChat.subscribe((event) => {
  if (event.message.startsWith(prefix)) {
    const command = event.message.split(' ');
    if (command[0] == prefix + "help") {
      Commands.run(`tellraw @a[name=${event.sender.name}] {"rawtext":[{"text":"circle <blockId> <radius> <direction> [hollow]\nsphere <blockId> <radius> [hollow]\nbrush <buildType>\n${brush}"}]}`);
      event.canceled = true;
    }
    else if (command[0] == prefix + "circle") {
      try {
        Commands.run(`testfor @a[name=${event.sender.name},tag=builder]`);
        if (command.length == 1 || command[1].length == 0) {
          Utilities.error(event.sender.name, "blockIdが設定されていません");
        }
        else if (command.length == 2 || command[2].length == 0) {
          Utilities.error(event.sender.name, "radiusが設定されていません");
        }
        else if (command.length == 3 || command[3].length == 0) {
          Utilities.error(event.sender.name, "directionが設定されていません");
        }
        else if (command.length == 4 || command.length == 5) {
          try {
            Commands.run(`execute @a[name=${event.sender.name}] ~ ~ ~ testforblock ~ ~ ~ ${command[1]}`);
          } catch (error) {
            error = JSON.parse(error);
            if (error.statusCode == -2147483648) {
              Utilities.error(event.sender.name, command[1] + "は存在しません");
              event.canceled = true;
              return;
            }
          }
          command[2] = parseInt(command[2]);
          if (command[2] > 1) {
            try {
              if (command.length == 5) {
                if (command[4] == "false") {
                  Utilities.circle(event.sender.name, command[1], command[2], command[3], 0, 0, false);
                  Commands.run(`tellraw @a[name=${event.sender.name}] {"rawtext":[{"text":"${command[1]}で${command[3]}方向の半径${command[2]}mの円形を作成しました"}]}`);
                }
                else if (command[4] == "true") {
                  Utilities.circle(event.sender.name, command[1], command[2], command[3], 0, 0, true);
                  Commands.run(`tellraw @a[name=${event.sender.name}] {"rawtext":[{"text":"${command[1]}で${command[3]}方向の半径${command[2]}mの中空の円形を作成しました"}]}`);
                }
                else {
                  Utilities.error(event.sender.name, "hollowはfalse, trueのみです");
                }
              }
              else {
                Utilities.circle(event.sender.name, command[1], command[2], command[3]);
                Commands.run(`tellraw @a[name=${event.sender.name}] {"rawtext":[{"text":"${command[1]}で${command[3]}方向の半径${command[2]}mの円形を作成しました"}]}`);
              }
            } catch (error) { }
          }
          else {
            Utilities.error(event.sender.name, "radiusは1mよりも大きくしてください");
          }
        }
        else {
          Utilities.error(event.sender.name, "コマンドが間違っています");
        }
      } catch (error) {
        Utilities.error(event.sender.name, "権限がありません");
      }
      event.canceled = true;
    }
    else if (command[0] == prefix + "sphere") {
      try {
        Commands.run(`testfor @a[name=${event.sender.name},tag=builder]`);
        if (command.length == 1 || command[1].length == 0) {
          Utilities.error(event.sender.name, "blockIdが設定されていません");
        }
        else if (command.length == 2 || command[2].length == 0) {
          Utilities.error(event.sender.name, "radiusが設定されていません");
        }
        else if (command.length == 3 || command.length == 4) {
          try {
            Commands.run(`execute @a[name=${event.sender.name}] ~ ~ ~ testforblock ~ ~ ~ ${command[1]}`);
          } catch (error) {
            error = JSON.parse(error);
            if (error.statusCode == -2147483648) {
              Utilities.error(event.sender.name, command[1] + "は存在しません");
              event.canceled = true;
              return;
            }
          }
          command[2] = parseInt(command[2]);
          if (command[2] > 1) {
            if (command.length == 4) {
              if (command[3] == "false") {
                Utilities.sphere(event.sender.name, command[1], command[2], 0, false);
                Commands.run(`tellraw @a[name=${event.sender.name}] {"rawtext":[{"text":"${command[1]}で半径${command[2]}mの球体を作成しました"}]}`);
              }
              else if (command[3] == "true") {
                Utilities.sphere(event.sender.name, command[1], command[2], 0, true);
                Commands.run(`tellraw @a[name=${event.sender.name}] {"rawtext":[{"text":"${command[1]}で半径${command[2]}mの中空の球体を作成しました"}]}`);
              }
              else {
                Utilities.error(event.sender.name, "hollowはfalse, trueのみです");
              }
            }
            else {
              Utilities.sphere(event.sender.name, command[1], command[2]);
              Commands.run(`tellraw @a[name=${event.sender.name}] {"rawtext":[{"text":"${command[1]}で半径${command[2]}mの球体を作成しました"}]}`);
            }
          }
          else {
            Utilities.error(event.sender.name, "radiusは1mよりも大きくしてください");
          }
        }
        else {
          Utilities.error(event.sender.name, "コマンドが間違っています");
        }
      } catch (error) {
        Utilities.error(event.sender.name, "権限がありません");
      }
      event.canceled = true;
    }
    else if (command[0] == prefix + "brush") {
      try {
        Commands.run(`testfor @a[name=${event.sender.name},tag=builder]`);
        if (command.length == 1 || command[1].length == 0) {
          Utilities.error(event.sender.name, "buildTypeが設定されていません");
        }
        else if (command[1] == "sphere") {
          if (command.length == 2 || command[2].length == 0) {
            Utilities.error(event.sender.name, "blockIdが設定されていません");
          }
          else if (command.length == 3 || command[3].length == 0) {
            Utilities.error(event.sender.name, "radiusが設定されていません");
          }
          else if (command.length == 4 || command.length == 5) {
            try {
              Commands.run(`execute @a[name=${event.sender.name}] ~ ~ ~ testforblock ~ ~ ~ ${command[2]}`);
            } catch (error) {
              error = JSON.parse(error);
              if (error.statusCode == -2147483648) {
                Utilities.error(event.sender.name, command[2] + "は存在しません");
                event.canceled = true;
                return;
              }
            }
            command[3] = parseInt(command[3]);
            if (command[3] > 1) {
              for (let i = 0; i < brush.length; i++) {
                if (brush[i][1] == event.sender.name) {
                  brush.splice(i, 1);
                }
              }
              if (command.length == 5) {
                if (command[4] == "false") {
                  brush[brush.length] = [command[1], event.sender.name, command[2], command[3], false];
                  Commands.run(`tellraw @a[name=${event.sender.name}] {"rawtext":[{"text":"ブラシを${command[2]}で半径${command[3]}mの球体に設定しました"}]}`);
                }
                else if (command[4] == "true") {
                  brush[brush.length] = [command[1], event.sender.name, command[2], command[3], true];
                  Commands.run(`tellraw @a[name=${event.sender.name}] {"rawtext":[{"text":"ブラシを${command[2]}で半径${command[3]}mの中空の球体に設定しました"}]}`);
                }
                else {
                  Utilities.error(event.sender.name, "hollowはfalse, trueのみです");
                }
              }
              else {
                brush[brush.length] = [command[1], event.sender.name, command[2], command[3], false];
                Commands.run(`tellraw @a[name=${event.sender.name}] {"rawtext":[{"text":"ブラシを${command[2]}で半径${command[3]}mの球体に設定しました"}]}`);
              }
            }
            else {
              Utilities.error(event.sender.name, "radiusは1mよりも大きくしてください");
            }
          }
          else {
            Utilities.error(event.sender.name, "コマンドが間違っています");
          }
        }
        else if (command[1] == "circle") {
          if (command.length == 2 || command[2].length == 0) {
            Utilities.error(event.sender.name, "blockIdが設定されていません");
          }
          else if (command.length == 3 || command[3].length == 0) {
            Utilities.error(event.sender.name, "radiusが設定されていません");
          }
          else if ((command.length == 4 || command[4].length == 0) && command[1] == "circle") {
            Utilities.error(event.sender.name, "directionが設定されていません");
          }
          else if (command.length == 5 || command.length == 6) {
            try {
              Commands.run(`execute @a[name=${event.sender.name}] ~ ~ ~ testforblock ~ ~ ~ ${command[2]}`);
            } catch (error) {
              error = JSON.parse(error);
              if (error.statusCode == -2147483648) {
                Utilities.error(event.sender.name, command[2] + "は存在しません");
                event.canceled = true;
                return;
              }
            }
            command[3] = parseInt(command[3]);
            if (command[3] > 1) {
              if (command[4] != "x" && command[4] != "y" && command[4] != "z") {
                Utilities.error(event.sender.name, "directionはx, y, zのみです");
              }
              else {
                for (let i = 0; i < brush.length; i++) {
                  if (brush[i][1] == event.sender.name) {
                    brush.splice(i, 1);
                  }
                }
                try {
                  if (command.length == 6) {
                    if (command[5] == "false") {
                      brush[brush.length] = [command[1], event.sender.name, command[2], command[3], command[4], false];
                      Commands.run(`tellraw @a[name=${event.sender.name}] {"rawtext":[{"text":"ブラシを${command[2]}で${command[4]}方向の半径${command[3]}mの円形に設定しました"}]}`);
                    }
                    else if (command[5] == "true") {
                      brush[brush.length] = [command[1], event.sender.name, command[2], command[3], command[4], true];
                      Commands.run(`tellraw @a[name=${event.sender.name}] {"rawtext":[{"text":"ブラシを${command[2]}で${command[4]}方向の半径${command[3]}mの中空の円形に設定しました"}]}`);
                    }
                    else {
                      Utilities.error(event.sender.name, "hollowはfalse, trueのみです");
                    }
                  }
                  else {
                    brush[brush.length] = [command[1], event.sender.name, command[2], command[3], command[4], false];
                    Commands.run(`tellraw @a[name=${event.sender.name}] {"rawtext":[{"text":"ブラシを${command[2]}で${command[4]}方向の半径${command[3]}mの円形に設定しました"}]}`);
                  }
                } catch (error) { }
              }
            }
            else {
              Utilities.error(event.sender.name, "radiusは1mよりも大きくしてください");
            }
          }
          else {
            Utilities.error(event.sender.name, "コマンドが間違っています");
          }
        }
        else {
          Utilities.error(event.sender.name, "存在しないbuildTypeです");
        }
      } catch (error) {
        Utilities.error(event.sender.name, "権限がありません");
      }
      event.canceled = true;
    }
  }
});

World.events.tick.subscribe(() => {
  try {
    Commands.run(`testfor @a[tag=brush,c=1]`);
    for (let i = 0; i < 100; i++) {
      try {
        Commands.run(`execute @a[tag=brush,c=1] ~ ~ ~ testforblock ^ ^ ^${i} air`);
      } catch (error) {
        for (let j of brush) {
          try {
            Commands.run(`execute @a[tag=brush,c=1] ~ ~ ~ execute @s[name=!${j[1]}] ~ ~ ~ testfor @s`);
          } catch (error) {
            if (j[0] == "circle") {
              Utilities.circle(j[1], j[2], j[3], j[4], 0, i, j[5]);
            }
            else if (j[0] == "sphere") {
              Utilities.sphere(j[1], j[2], j[3], i, j[4]);
            }
            break;
          }
        }
        break;
      }
    }
  } catch (error) { }
  Commands.run(`tag @a[tag=brush,c=1] remove brush`);
});